10 ' -----------------------------------------------------------------------
20 ' MINMORSE.BAS --- V.1.6-KPII - Kaypro II keyboard only 25wpm version.
30 ' This program is in the public domain.
40 ' -----------------------------------------------------------------------
50 WPM=25 : WT=1!
60 PRINT: PRINT: PRINT: PRINT: PRINT: PRINT: PRINT: PRINT: PRINT: PRINT:PRINT
70 PRINT"****************************************";
80 PRINT"***************************************"
90 PRINT"*     MinMorse.bas --- version 1.6 --- O";
100 PRINT"ctober-16-1995 for the Kaypro II.     *"
110 PRINT"****************************************";
120 PRINT"***************************************"
130 PRINT
140 PRINT"This program keys Morse code characters ";
150 PRINT"out the Kaypro II RS-232 port pins 2/7."
160 PRINT"Use a diode and small 12vdc mercury wett";
170 PRINT"ed high speed relay as a keying device."
180 PRINT"Connect the diode cathode to pin 7 and o";
190 PRINT"ne lead of the relay coil to pin 2."
200 PRINT"Connect the free end of the diode to the";
210 PRINT" free relay coil end.  Use the normally"
220 PRINT"open contacts of the relay to key the tr";
230 PRINT"ansmitting device (radio set key line)."
240 PRINT
250 PRINT"The default keying rate is 25 wpm.  Ente";
260 PRINT"r ESC followed by the new keying rate"
270 PRINT"if you wish to change the keying rate.  ";
280 PRINT"Enter ESC 0 to key the standard PARIS"
290 PRINT"test pattern at 20wpm for 1 minute.  Ent";
300 PRINT"er ESC 1 to exit the program to CP/M."
310 PRINT"Enter ESC 2 to set the keying weighting."
320 PRINT
330 PRINT"****************************************";
340 PRINT"***************************************"
350 PRINT
360 ' ------------------------------------------------------------------------
370 ' Set up the Morse Code Translation Table (full ITU Morse capability).
380 NUMCODES=60 'chars .,/?-+;:=()@"_\][{}|<> plus 26 alpabet and 10 numbers
390 DIM CODES$(60) ' set to same number as numcodes
400 DIM CHARS$(60) ' set to same number as numcodes
410 FOR I=0 TO NUMCODES-1 : READ CODES$(I) : NEXT I
420 FOR I=0 TO NUMCODES-1 : READ CHARS$(I) : NEXT I
430 ' Morse Code Translation Table From 1992 ARRL Handbook For Radio Amateurs.
440 ' Code strings, in one-to-one correspondence with characters, below.
450 DATA ".-", "-...", "-.-.", "-..", ".", "..-.", "--.", "...."
460 DATA "..", ".---", "-.-", ".-..", "--"
470 DATA "-.", "---", ".--.", "--.-", ".-.", "...", "-"
480 DATA "..-", "...-", ".--", "-..-", "-.--", "--.."
490 DATA "-----", ".----", "..---", "...--", "....-", "....."
500 DATA "-....", "--...", "---..", "----."
510 DATA ".-.-.-", "--..--", "-..-.", "..--..", "-....-", "-...-"
520 DATA "...-..-", "-.--.", "-.--.-", "-.-.-.", "---...", ".-.-.", ".----."
530 DATA ".-..-."
540 DATA ".-.-.."
550 DATA "..--.-"
560 DATA "...-.-"
570 DATA "-...-.-"
580 DATA ".-..."
590 DATA "-.-.-"
600 DATA "...-."
610 DATA "........"
620 DATA ".-.-", "..--"
630 ' add additional ones here
640 ' Characters recognized by the program.
650 DATA "A", "B", "C", "D", "E", "F", "G", "H"
660 DATA "I", "J", "K", "L", "M"
670 DATA "N", "O", "P", "Q", "R", "S", "T"
680 DATA "U", "V", "W", "X", "Y", "Z"
690 DATA "0", "1", "2", "3", "4", "5"
700 DATA "6", "7", "8", "9"
710 DATA ".", ",", "/", "?", "-", "="
720 DATA "$", "(", ")", ";", ":", "+", "'"
730 DATA 34 
740 DATA "@"
750 DATA "_"
760 DATA "\"
770 DATA "]"
780 DATA "["
790 DATA "{"
800 DATA "}"
810 DATA "|", "<", ">"
820 ' add additional ones here
830 ' ----------------------------------------------------------------------
840 ' Calculate element timings. units are for-next loop iterations.
850 ' A dit=1, dah=3, ditspace=1, characterspace=3, wordspace=7 units.
860 ' Use 1000 loops/25wpm=40 loops for a dit length on a KPII/2.5mhz.
870 ' Use 1600 loops/25wpm=64 loops for a dit length on a KP4/4.0mhz.
880 ' Because of relay and clock slowness these may require adjustment.
890 ELE=INT(1000/WPM): DIT=ELE: DAH=3*DIT: CHARSP=INT(2*ELE): WRTSP=INT(6*ELE)
900 ' Define character type checking functions
910 DEF FNLOWER(C$) = "a"<=C$ AND C$<="z"
920 DEF FNUPPER(C$) = "A"<=C$ AND C$<="Z"
930 DEF FNDIGIT(C$) = "0"<=C$ AND C$<="9"
940 DEF FNTOUPPER$(C$) = CHR$(ASC(C$)-32)
950 ' ----------------------------------------------------------------------
960 ' Main loop to generate each character and key and/or print it.
970 C$=INPUT$(1)
980 IF C$=CHR$(27) THEN GOSUB 1560: GOTO 970
990 IF " "=C$ OR C$=CHR$(13) THEN GOSUB 1410: GOTO 1340
1000 IF "."=C$ THEN MORSE=36: GOTO 1290  ' set morse to codes$ array index
1010 IF ","=C$ THEN MORSE=37: GOTO 1290
1020 IF "/"=C$ THEN MORSE=38: GOTO 1290
1030 IF "?"=C$ THEN MORSE=39: GOTO 1290
1040 IF "-"=C$ THEN MORSE=40: GOTO 1290
1050 IF "=" = C$ THEN MORSE=41: GOTO 1290
1060 IF "$" = C$ THEN MORSE=42: GOTO 1290
1070 IF "(" = C$ THEN MORSE=43: GOTO 1290
1080 IF ")" = C$ THEN MORSE=44: GOTO 1290
1090 IF ";" = C$ THEN MORSE=45: GOTO 1290
1100 IF ":" = C$ THEN MORSE=46: GOTO 1290
1110 IF "+" = C$ THEN MORSE=47: GOTO 1290
1120 IF "'" = C$ THEN MORSE=48: GOTO 1290
1130 IF CHR$(34) = C$ THEN MORSE=49: GOTO 1290
1140 IF "@" = C$ THEN MORSE=50: GOTO 1290
1150 IF "_" = C$ THEN MORSE=51: GOTO 1290
1160 IF "\" = C$ THEN MORSE=52: GOTO 1290
1170 IF "]" = C$ THEN MORSE=53: GOTO 1290
1180 IF "[" = C$ THEN MORSE=54: GOTO 1290
1190 IF "{" = C$ THEN MORSE=55: GOTO 1290
1200 IF "}" = C$ THEN MORSE=56: GOTO 1290
1210 IF "|" = C$ THEN MORSE=57: GOTO 1290
1220 IF "<" = C$ THEN MORSE=58: GOTO 1290
1230 IF ">" = C$ THEN MORSE=59: GOTO 1290
1240 ' add more here as needed
1250 IF FNLOWER(C$) THEN C$ = FNTOUPPER$(C$)
1260 IF FNUPPER(C$) THEN MORSE=ASC(C$)-ASC("A"):  GOTO 1290
1270 IF FNDIGIT(C$) THEN MORSE=ASC(C$)-ASC("0")+26: GOTO 1290
1280 GOTO 1350   ' non-morse character so skip it
1290 ' sound dit for each ".", dah for each "-" in string codes$(morse)
1300 FOR I=1 TO LEN(CODES$(MORSE))
1310   IF MID$(CODES$(MORSE),I,1) = "." THEN GOSUB 1440 ELSE GOSUB 1500
1320 NEXT
1330 GOSUB 1380
1340 REM PRINT C$; ' do not print to see if it will speed things up
1350 GOTO 960
1360 ' ---------------------------------------------------------------------
1370 ' Delay an intercharacter space.
1380 REM
1390 FOR J=1 TO CHARSP : NEXT J : RETURN
1400 ' Delay an interword space.
1410 REM
1420 FOR J=1 TO WRDSP : NEXT J : RETURN
1430 ' Key a dit (key down turn motor on then off) and a ditspace.
1440 OUT 6,21 : OUT 6,24
1450 FOR J=1 TO DIT : NEXT J
1460 OUT 6,24
1470 FOR J=1 TO DIT : NEXT J
1480 RETURN
1490 ' Key a dah (key down turn motor on then off) and a ditspace.
1500 OUT 6,21 : OUT 6,24
1510 FOR J=1 TO DAH : NEXT J
1520 OUT 6,24
1530 FOR J=1 TO DIT : NEXT J
1540 RETURN
1550 ' -----------------------------------------------------------------------
1560 ' Get speed in wpm
1570 INPUT "Enter keying speed in wpm.....",WPM
1580 IF (WPM<1) THEN WPM=20: C$=" ": GOSUB 1690
1590 IF (WPM=1) THEN STOP
1600 IF (WPM=2) THEN GOSUB 1850
1610 IF (WPM>99) THEN GOTO 1570
1620 ' calculate element timings. units are clock ticks, which are at 18.2hz.
1630 ' weighting is a multiplier of 1.00 to 2.00 times elemental dit value
1640 REM DIT = INT(600/WPM): DAH = 3*DIT : CHARSP=2*DIT : WRDSP=6*DIT
1650 ELE=INT(1000/WPM)
1660 DIT=INT(ELE*WT): DAH=3*DIT: CHARSP=INT(2*ELE): WRDSP=INT(6*ELE)
1670 RETURN
1680 ' -----------------------------------------------------------------------
1690 ' Send test PARIS pattern at 20 wpm with no weighting.
1700 WPM=20: DIT=INT(1000/WPM): DAH=3*DIT: CHARSP=INT(2*DIT): WRDSP=INT(6*DIT)
1710 FOR L=1 TO 20
1720 M=15:GOSUB 1780:M=0:GOSUB 1780:M=17:GOSUB 1780:M=8:GOSUB 1780:M=18:GOSUB 1780
1730 GOSUB 1410
1740 NEXT L
1750 GOSUB 1410
1760 RETURN
1770 ' ----------------------------------------------------------------------
1780 FOR I=1 TO LEN(CODES$(M))
1790   IF MID$(CODES$(M),I,1) = "." THEN GOSUB 1440 ELSE GOSUB 1500
1800 NEXT I 
1810 GOSUB 1380
1820 REM PRINT C$; ' do not print to see if it will speed things up
1830 RETURN
1840 ' ----------------------------------------------------------------------
1850 INPUT"Enter weighted keying speed in wpm.....",WPM
1860 INPUT"Enter weighting factor from 0-100 percent weighting.....",WT
1870 IF (WT<0) OR (WT>100) THEN GOTO 1860
1880 WT=1!+(WT/100!) ' set the weighting multiplier 1.00-2.00
1890 WPM=INT(WPM*WT) ' set the wpm faster to compensate for weighting
1900 RETURN
 ' set the weighting multiplier 1.00-2.00
1890 WPM=INT(WPM*WT) ' set the wp