10    ' Morse Code Practice Program. Elwood Downey, WB0OEW, August, 1983.
20    ' Written for the IBM PC in Microsoft Basica, V1.1, for PC-DOS V1.1.
30    ' Revised November, 1983, to allow typing in responses.
40    ' REVISED JUN 1987 BY R.D. KEYS TO ACCEPT DEFAULT MORSE.TXT FILENAME
50    '
60    FILNAM$="MORSE.TXT" : REM ACCEPT DEFAULT MORSE.TXT FILENAME (RDK)
70    CLS
80    KEY OFF
90    TYPEWAIT = 200     ' time to wait if user typing in responses
100   F = 750             ' initial tone frequency
110   DOTYPE = 0
120   GOSUB 1450         ' give directions and ask setup questions
130   '
140   ' initialize code strings.
150   ' to add more characters, such as apostrophe, increase numcodes,
160   ' add code string and character at end of current lists and add case
170   ' to main loop, below.
180   NUMCODES = 41  ' . , / ? - plus 26 + 10
190   DIM CODES$(NUMCODES-1)
200   DIM CHARS$(NUMCODES-1)
210   FOR I=0 TO NUMCODES-1
220     READ CODES$(I)
230   NEXT
240  FOR I=0 TO NUMCODES-1
250    READ CHARS$(I)
260  NEXT
270  ' code strings. in one-to-one correspondence with characters, below.
280  DATA ".-", "-...", "-.-.", "-..", ".", "..-.", "--.", "...."
290  DATA "..", ".---", "-.-", ".-..", "--"
300  DATA "-.", "---", ".--.", "--.-", ".-.", "...", "-"
310  DATA "..-", "...-", ".--", "-..-", "-.--", "--.."
320  DATA "-----", ".----", "..---", "...--", "....-", "....."
330  DATA "-....", "--...", "---..", "----."
340  DATA ".-.-.-", "--..--", "-..-.", "..--..", "-...-"
350  ' characters.
360  DATA "A", "B", "C", "D", "E", "F", "G", "H"
370  DATA "I", "J", "K", "L", "M"
380  DATA "N", "O", "P", "Q", "R", "S", "T"
390  DATA "U", "V", "W", "X", "Y", "Z"
400  DATA "0", "1", "2", "3", "4", "5"
410  DATA "6", "7", "8", "9"
420  DATA ".", ",", "/", "?", "-"
430 '
440 ' set up arrow keys to change speed and frequency.
450 PRINT CHR$(24); " "; CHR$(25); " to raise or lower tone,   ";
460 PRINT CHR$(27); " "; CHR$(26); " for slower or faster code."
470 PRINT "Ctrl-Break to quit, F9 to pause."
480 PRINT
490 ON KEY(11) GOSUB 990: KEY(11) ON
500 ON KEY(14) GOSUB 1000: KEY(14) ON
510 ON KEY(12) GOSUB 1040: KEY(12) ON
520 ON KEY(13) GOSUB 1030: KEY(13) ON
530 ON KEY(9) GOSUB 1190: KEY(9) ON
540 '
550 ' init constants and screen.
560 SIL = 32767         ' special code for no tone
570 GOSUB 1070          ' calculate dit, dah and space lengths.
580 GOSUB 1130          ' display wpm and freq
590 '
600 ' define character type checking functions
610  DEF FNLOWER(C$) = "a"<=C$ AND C$<="z"
620  DEF FNUPPER(C$) = "A"<=C$ AND C$<="Z"
630  DEF FNDIGIT(C$) = "0"<=C$ AND C$<="9"
640  DEF FNTOUPPER$(C$) = CHR$(ASC(C$)-32)
650 '
660 ' main loop. read (or generate) each character, sound it and print it.
670  IF RANFILE THEN GOSUB 1260 : GOTO 700
680  IF EOF(1) THEN PRINT CHR$(7) : CLOSE : STOP
690  C$=INPUT$(1,#1)
700  IF " "=C$ OR C$=CHR$(13) THEN GOSUB 940: GOTO 810
710  IF "."=C$ THEN MORSE=36: GOTO 800  ' set morse to codes$ array index
720  IF ","=C$ THEN MORSE=37: GOTO 800
730  IF "/"=C$ THEN MORSE=38: GOTO 800
740  IF "?"=C$ THEN MORSE=39: GOTO 800
750  IF "-"=C$ THEN MORSE=40: GOTO 800
760  IF FNLOWER(C$) THEN C$ = FNTOUPPER$(C$)
770  IF FNUPPER(C$) THEN MORSE=ASC(C$)-ASC("A"):  GOTO 800
780  IF FNDIGIT(C$) THEN MORSE=ASC(C$)-ASC("0")+26: GOTO 800
790  GOTO 820   ' non-morse character so skip it
800  IF DOTYPE>0 THEN GOSUB 1310: ELSE GOSUB 850 ' wait for type in or sound now
810  PRINT C$;
820  GOTO 670
830 '
840 ' sound dit for each ".", dah for each "-" in string codes$(morse)
850 FOR I=1 TO LEN(CODES$(MORSE))
860   IF MID$(CODES$(MORSE),I,1) = "." THEN GOSUB 950 ELSE GOSUB 960
870 NEXT
880 GOSUB 930
890 RETURN
900 '
910 ' produce elemental sounds, or silences.
920  SOUND SIL,DIT: RETURN      ' element space
930 SOUND SIL,ELE*2: RETURN     ' character space, allow for previous trailing
940 SOUND SIL,ELE*6: RETURN   ' word space, allow for trailing.
950 SOUND F,DIT: GOSUB 920: RETURN        ' dit
960 SOUND F,DAH: GOSUB 920: RETURN        ' dah
970 '
980 ' change frequency of tone
990 F = F*1.104: GOSUB 1130: RETURN
1000 F = F/1.104: GOSUB 1130: RETURN
1010 '
1020 ' change speed; update element timings.
1030 WPM = WPM+1: GOSUB 1070: GOSUB 1130: RETURN
1040 WPM = WPM-1: GOSUB 1070: GOSUB 1130: RETURN
1050 '
1060 ' calculate element timings. units are clock ticks, which are at 18.2hz.
1070 IF WPM<13 THEN CWPM=13 ELSE CWPM=WPM
1080 DIT = 21.84/CWPM: DAH = 3*DIT
1090 IF WPM>=13 THEN ELE=DIT ELSE ELE=DIT*((CWPM/WPM-1)*13+2)/2
1100 RETURN
1110 '
1120 ' display current speed and frequency. return cursor where it was.
1130 COL=POS(0): ROW=CSRLIN: LOCATE 1,64
1140 PRINT "wpm: "; WPM: LOCATE 2,63: PRINT "freq: "; F; "     "
1150 LOCATE ROW,COL
1160 RETURN
1170 '
1180 ' handle F9, the pause control.
1190 COL9=POS(0): ROW9=CSRLIN
1200 LOCATE 24,30: COLOR 16,7: PRINT " Press any key to continue ";
1210 X$=INKEY$: IF X$="" THEN 1210
1220 LOCATE 24,30: COLOR 2,0:  PRINT "                           ";
1230 LOCATE ROW9,COL9: RETURN
1240 '
1250 ' set c$ to random supported character.
1260 ' force a space every fifth time and a newline every 13 groups.
1270 IF NCHRS=5 THEN C$=" ": NCHRS=0: NGRPS=NGRPS+1: RETURN
1280 IF NGRPS=13 THEN C$=CHR$(13): NGRPS=0: NCHRS=0: RETURN
1290 C$ = CHARS$(RND*(NUMCODES-1)): NCHRS=NCHRS+1: RETURN
1300 '
1310 ' sound character in codes$(morse) and let user type in response.
1320 ' repeat until get it right.
1330 RIGHT=0
1340 WHILE RIGHT=0
1350   GOSUB 850       ' sound out character
1360   N=0
1370   N=N+1: X$=INKEY$: IF X$="" AND N<TYPEWAIT GOTO 1370
1380   IF FNLOWER(X$) THEN X$=FNTOUPPER$(X$)
1390   IF C$<>X$ AND X$<>"" THEN SOUND 2000,2: SOUND SIL,5
1400   IF C$=X$ THEN RIGHT=1
1410 WEND
1420 RETURN
1430  '
1440  ' give info and ask setup questions.
1450  PRINT "              Morse Code Practice Program."
1460  PRINT
1470  PRINT "This program sounds out morse code characters. The characters"
1480  PRINT "may come from a file, from the keyboard, or be generated randomly.
1490  PRINT
1500  PRINT "The program may be used in two ways."
1510  PRINT
1520  PRINT "Characters may be continuously sounded and printed on the screen."
1530  PRINT "This form is good practice for copying code by hand."
1540  PRINT
1550  PRINT "The program may also be used to sound one character at a time,"
1560  PRINT "repeating until the correct character is typed on the keyboard."
1570  PRINT "A high tone indicates an incorrect response. This form is good"
1580  PRINT "practice for typing code."
1590  PRINT
1600  PRINT "At any time while the program is running, the left and right"
1610  PRINT "arrow keys change the code speed and the up and down arrows"
1620  PRINT "change the pitch of the tone."
1630  PRINT
1640  PRINT "Type any key to continue ";
1650  X$=INKEY$: IF X$="" GOTO 1650
1660  CLS
1670  '
1680  ' select input source: either from a file, the keyboard or random.
1690  ' if input is not from keyboard, also ask if want to type in responses.
1700  PRINT "Select source of practice characters. Type:
1710  PRINT "      random    for random characters,"
1720  PRINT "      keyboard  to sound characters typed from keyboard,"
1730  PRINT "      MORSE.TXT (default filename for practice session),"
1740  PRINT "      or type a file name from which to read characters: "
1750  INPUT F$
1760  REM ACCEPT DEFAULT PRACTICE FILE IF INPUT IS BLANK LINE (RDK)
1770  IF F$="" THEN F$=FILNAM$ : GOTO 1840 : REM DEFAULT FILE (RDK)
1780  IF F$=FILNAM$ THEN GOTO 1840 : REM DEFAULT FILE (RDK)
1790  IF F$="keyboard" THEN F$="kybd:"
1800  IF F$="kybd:" THEN DOTYPE=0: GOTO 1840
1810    INPUT "type in each character in response to sound? (y or n) ", X$
1820    IF LEFT$(X$,1)="y" THEN DOTYPE=1
1830  IF F$="random" GOTO 1860
1840    RANFILE=0: OPEN F$ FOR INPUT AS #1
1850    GOTO 1870
1860    RANFILE=1: RANDOMIZE VAL(RIGHT$(TIME$,2)): NCHRS=0: NGRPS=0
1870  '
1880  ' select speed
1890  INPUT "words per minute? ", WPM
1900  '
1910  CLS
1920  RETURN
