10    ' Morse Code Practice Program. Elwood Downey, WB0OEW, August, 1983.
20    ' Written for the IBM PC in Microsoft Basica, V1.1, for PC-DOS V1.1.
30    ' Revised November, 1983, to allow typing in responses. 
40    ' REVISED JUN 1987 BY R.D. KEYS TO ACCEPT DEFAULT MORSE.TXT FILENAME
45    ' Revised Sept 1995 by R.D. Keys to fix keyboard input routines.
50    ' Revised Sept 1995 by R.D. Keys to have more key characters, and to
60    ' toggle the RS-232 port transmit line pin 2 for operation of an
70    ' external 12 volt dc reed relay (7ma coil current rating) using the
80    ' following simple schematic made in a plug shell on serial port 1.
90    '                                 \  
100   ' RS-232 Pin 2                    |\ |band
110   ' >-------------------------------| >|-----*\/\/\/\/\/\/\/*----+
120   '                                 |/ |         12 vdc reed     |
130   '                                 /            relay coil      |
140   '                                                              |
150   '                               50 v 1 amp                     |
160   '                               rectifier diode                |
170   ' >------------------------------------------------------------+
180   ' RS-232 Pin 7
190   '
200   ' Note: if the thing keys in the wrong polarity, then reverse the diode
210   '       or change PUP% and PDWN% values.
220   '
230   ' Note: a piezo-electric beeper can be substituted for the reed relay for
240   '       a very simple practice oscillator for training purposes, or the
250   '       relay can be used to key your own code practice oscillator.
260   '
270   '
280   '
290   FILNAM$="MORSE.TXT" : REM ACCEPT DEFAULT MORSE.TXT FILENAME (RDK)
300 ' Initialize the serial port pin 2 (data out) to high by reading in the
301 ' modem control register using an input(&h3fb), then or'ing it with 40h
302 ' to turn on the signal.  Use the original input value to turn it back off.
320 PUP% = INP(&H3FB)
321 PDWN% = PUP% OR &H40
330   CLS
340   KEY OFF
350   TYPEWAIT = 200     ' time to wait if user typing in responses
360   F = 600            ' initial tone frequency
370   '
380   GOSUB 2170         ' give directions and ask setup questions
390   '
400   ' initialize code strings.
410   ' to add more characters, such as apostrophe, increase numcodes,
420   ' add code string and character at end of current lists and add case
430   ' to main loop, below.
440   '
450   ' REMEMBER to increment for the remaining characters
460   '   1.  doublequote
470   '   2.  paragraph sign
480   '   3.  underscore sign
490   '   4.  any additional prosigns not already included
500   '
510   '
520  NUMCODES = 49  'chars .,/?-+;:=() plus 26 alpabet and 10 numbers
530  DIM CODES$(NUMCODES-1)
540  DIM CHARS$(NUMCODES-1)
550  FOR I=0 TO NUMCODES-1
560    READ CODES$(I)
570  NEXT
580  FOR I=0 TO NUMCODES-1
590    READ CHARS$(I)
600  NEXT
610  '
620  ' Morse Code Translation Table From 1992 ARRL Handbook For Radio Amateurs.
630  ' Code strings, in one-to-one correspondence with characters, below.
640  DATA ".-", "-...", "-.-.", "-..", ".", "..-.", "--.", "...."
650  DATA "..", ".---", "-.-", ".-..", "--"
660  DATA "-.", "---", ".--.", "--.-", ".-.", "...", "-"
670  DATA "..-", "...-", ".--", "-..-", "-.--", "--.."
680  DATA "-----", ".----", "..---", "...--", "....-", "....."
690  DATA "-....", "--...", "---..", "----."
700  DATA ".-.-.-", "--..--", "-..-.", "..--..", "-....-", "-...-"
710  DATA "...-..-", "-.--.", "-.--.-", "-.-.-.", "---...", ".-.-.", ".----."
720  REM DATA ".-..-." 'rem this is the doublequote value if fixed below
730  REM DATA ".-.-.." 'rem this is the paragraph sign
740  REM DATA "..--.-" 'rem this is the underscore sign
750  REM add additional ones here
760  ' Characters recognized by the program.
770  DATA "A", "B", "C", "D", "E", "F", "G", "H"
780  DATA "I", "J", "K", "L", "M"
790  DATA "N", "O", "P", "Q", "R", "S", "T"
800  DATA "U", "V", "W", "X", "Y", "Z"
810  DATA "0", "1", "2", "3", "4", "5"
820  DATA "6", "7", "8", "9"
830  DATA ".", ",", "/", "?", "-", "="
840  DATA "$", "(", ")", ";", ":", "+", "'"
850  REM DATA "doubleqouteasciicharactervalue"
860  REM DATA "paragraphsignasciicharactervalue"
870  REM DATA "underscoresingasciicharactervalue"
880  REM add additional ones here
890 '
900 ' set up arrow keys to change speed and frequency.
910 PRINT CHR$(24); " "; CHR$(25); " to raise or lower tone,   ";
920 PRINT CHR$(27); " "; CHR$(26); " for slower or faster code."
930 PRINT "Ctrl-Break to quit, F9 to pause."
940 PRINT
950 ON KEY(11) GOSUB 1710: KEY(11) ON
960 ON KEY(14) GOSUB 1720: KEY(14) ON
970 ON KEY(12) GOSUB 1760: KEY(12) ON
980 ON KEY(13) GOSUB 1750: KEY(13) ON
990 ON KEY(9) GOSUB 1910: KEY(9) ON
1000 '
1010 ' init constants and screen.
1020 SIL = 32767         ' special code for no tone
1030 GOSUB 1790          ' calculate dit, dah and space lengths.
1040 GOSUB 1850          ' display wpm and freq
1050 '
1060 ' define character type checking functions
1070  DEF FNLOWER(C$) = "a"<=C$ AND C$<="z"
1080  DEF FNUPPER(C$) = "A"<=C$ AND C$<="Z"
1090  DEF FNDIGIT(C$) = "0"<=C$ AND C$<="9"
1100  DEF FNTOUPPER$(C$) = CHR$(ASC(C$)-32)
1110 '
1120 ' main loop. read (or generate) each character, sound it and print it.
1130  IF RANFILE THEN GOSUB 1980 : GOTO 1160
1135  IF F$="kybd:" THEN C$=INPUT$(1) : GOTO 1160
1140  IF EOF(1) THEN PRINT CHR$(7) : CLOSE : SYSTEM
1150  C$=INPUT$(1,#1)
1160  IF " "=C$ OR C$=CHR$(13) THEN GOSUB 1640: GOTO 1390
1170  IF "."=C$ THEN MORSE=36: GOTO 1380  ' set morse to codes$ array index
1180  IF ","=C$ THEN MORSE=37: GOTO 1380
1190  IF "/"=C$ THEN MORSE=38: GOTO 1380
1200  IF "?"=C$ THEN MORSE=39: GOTO 1380
1210  IF "-"=C$ THEN MORSE=40: GOTO 1380
1220  IF "=" = C$ THEN MORSE=41: GOTO 1380
1230  IF "$" = C$ THEN MORSE=42: GOTO 1380
1240  IF "(" = C$ THEN MORSE=43: GOTO 1380
1250  IF ")" = C$ THEN MORSE=44: GOTO 1380
1260  IF ";" = C$ THEN MORSE=45: GOTO 1380
1270  IF ":" = C$ THEN MORSE=46: GOTO 1380
1280  IF "+" = C$ THEN MORSE=47: GOTO 1380
1290  IF "'" = C$ THEN MORSE=48: GOTO 1380
1300 REM IF "doublequoteasciivalue" = C$ THEN MORSE=49: GOTO 1380
1310 REM IF "paragraphsignasciivalue" = C$ THEN MORSE=50: GOTO 1380
1320 REM IF "underscoresignasciivalue" = C$ THEN MORSE=51: GOTO 1380
1330 REM add more here as needed
1340  IF FNLOWER(C$) THEN C$ = FNTOUPPER$(C$)
1350  IF FNUPPER(C$) THEN MORSE=ASC(C$)-ASC("A"):  GOTO 1380
1360  IF FNDIGIT(C$) THEN MORSE=ASC(C$)-ASC("0")+26: GOTO 1380
1370  GOTO 1400   ' non-morse character so skip it
1380  IF KEYTYPE > 0 THEN GOSUB 2030: ELSE GOSUB 1430  ' typein or soundnow
1390  PRINT C$;
1400  GOTO 1130
1410 '
1420 ' sound dit for each ".", dah for each "-" in string codes$(morse)
1430 FOR I=1 TO LEN(CODES$(MORSE))
1440   IF MID$(CODES$(MORSE),I,1) = "." THEN GOSUB 1660 ELSE GOSUB 1680
1450 NEXT
1460 GOSUB 1620
1470 RETURN
1480 '
1490 ' Produce elemental sounds, or silences.
1500 ' The port assignment of 3FC hex is for serial port 1 data output.
1510 ' If the rts/cts lines are used use port 3FB hex but use the following
1520 ' routine at the starting initialization to read the value in the port
1530 ' modem control register into a variable and then or the variable with
1540 ' with a 40h value to set the rts/cts lines and output THAT or'ed value.
1550 ' XXXX PORT%=inp(&H3FB)    ' get contents of modem control register
1560 ' XXXX PORT%=PORT% OR &H40 ' turn ON the Set Break Bit
1570 ' XXXX OUT &H3FB,PORT%     ' transmit bits to modem control register
1580 '
1590 ' Sound an intra character silent dit space.
1600 SOUND SIL,DIT : RETURN
1610 ' Sound an intercharacter space.
1620 SOUND SIL,ELE*2 : RETURN
1630 ' Sound an interword space.
1640 SOUND SIL,ELE*6 : RETURN
1650 ' Sound an actual elemental dit key down.
1660 OUT &H3FB,PDWN% : SOUND F,DIT : OUT &H3FB,PUP% : GOSUB 1600 : RETURN
1670 ' Sound an actual dah key down.
1680 OUT &H3FB,PDWN% : SOUND F,DAH : OUT &H3FB,PUP% : GOSUB 1600 : RETURN
1690 '
1700 ' change frequency of tone
1710 F = F*1.104: GOSUB 1850: RETURN
1720 F = F/1.104: GOSUB 1850: RETURN
1730 '
1740 ' change speed; update element timings.
1750 WPM = WPM+1: GOSUB 1790: GOSUB 1850: RETURN
1760 WPM = WPM-1: GOSUB 1790: GOSUB 1850: RETURN
1770 '
1780 ' calculate element timings. units are clock ticks, which are at 18.2hz.
1790 IF WPM<13 THEN CWPM=13 ELSE CWPM=WPM
1800 DIT = 21.84/CWPM: DAH = 3*DIT
1810 IF WPM>=13 THEN ELE=DIT ELSE ELE=DIT*((CWPM/WPM-1)*13+2)/2
1820 RETURN
1830 '
1840 ' display current speed and frequency. return cursor where it was.
1850 COL=POS(0): ROW=CSRLIN: LOCATE 1,64
1860 PRINT "wpm: "; WPM: LOCATE 2,63: PRINT "freq: "; F; "     "
1870 LOCATE ROW,COL
1880 RETURN
1890 '
1900 ' handle F9, the pause control.
1910 COL9=POS(0): ROW9=CSRLIN
1920 LOCATE 24,30: COLOR 16,7: PRINT " Press any key to continue ";
1930 X$=INKEY$: IF X$="" THEN 1930
1940 LOCATE 24,30: COLOR 2,0:  PRINT "				 ";
1950 LOCATE ROW9,COL9: RETURN
1960 '
1970 ' set c$ to random supported character.
1980 ' force a space every fifth time and a newline every 13 groups.
1990 IF NCHRS=5 THEN C$=" ": NCHRS=0: NGRPS=NGRPS+1: RETURN
2000 IF NGRPS=13 THEN C$=CHR$(13): NGRPS=0: NCHRS=0: RETURN
2010 C$ = CHARS$(RND*(NUMCODES-1)): NCHRS=NCHRS+1: RETURN
2020 '
2030 ' sound character in codes$(morse) and let user type in response.
2040 ' repeat until get it right.
2050 RIGHT=0
2060 WHILE RIGHT=0
2070   GOSUB 1430       ' sound out character
2080   N=0
2090   N=N+1: X$=INKEY$: IF X$="" AND N<TYPEWAIT GOTO 2090
2100   IF FNLOWER(X$) THEN X$=FNTOUPPER$(X$)
2110   IF C$<>X$ AND X$<>"" THEN SOUND 2000,2: SOUND SIL,5
2120   IF C$=X$ THEN RIGHT=1
2130 WEND
2140 RETURN
2150  '
2160  ' give info and ask setup questions.
2170  PRINT "		   Morse Code Practice Program."
2180  PRINT
2190  PRINT "This program sounds out morse code characters. The characters"
2200  PRINT "may come from a file, from the keyboard, or be generated randomly.
2210  PRINT
2220  PRINT "The program may be used in two ways."
2230  PRINT
2240  PRINT "Characters may be continuously sounded and printed on the screen."
2250  PRINT "This form is good practice for copying code by hand."
2260  PRINT
2270  PRINT "The program may also be used to sound one character at a time,"
2280  PRINT "repeating until the correct character is typed on the keyboard."
2290  PRINT "A high tone indicates an incorrect response. This form is good"
2300  PRINT "practice for typing code."
2310  PRINT
2320  PRINT "At any time while the program is running, the left and right"
2330  PRINT "arrow keys change the code speed and the up and down arrows"
2340  PRINT "change the pitch of the tone."
2350  PRINT
2360  PRINT "Type any key to continue ";
2370  X$=INKEY$: IF X$="" GOTO 2370
2380  CLS
2390  '
2400  ' select input source: either from a file, the keyboard or random.
2410  ' if input is not from keyboard, also ask if want to type in responses.
2420  PRINT "Select source of practice characters. Type:
2430  PRINT "	   random    for random characters,"
2440  PRINT "	   keyboard  to sound characters typed from keyboard,"
2450  PRINT "	   MORSE.TXT (default filename for practice session),"
2460  PRINT "	   or type a file name from which to read characters: "
2470  PRINT : INPUT "Your response: ", F$
2480  REM ACCEPT DEFAULT PRACTICE FILE IF INPUT IS BLANK LINE (RDK)
2490  IF F$="" THEN F$=FILNAM$ : GOTO 2560 : REM DEFAULT FILE (RDK)
2500  IF F$=FILNAM$ THEN GOTO 2560 : REM DEFAULT FILE (RDK)
2510  IF F$="keyboard" OR F$="KEYBOARD" OR F$="k" OR F$="K" THEN F$="kybd:"
2520  IF F$="kybd:" THEN KEYTYPE=0: RANFILE=0 : GOTO 2610
2530	INPUT "Type in each character in response to sound? (y or n) ", X$
2540	IF LEFT$(X$,1)="y" THEN KEYTYPE=1
2550  IF F$="random" OR F$="RANDOM" GOTO 2580
2560	RANFILE=0: OPEN F$ FOR INPUT AS #1
2570	GOTO 2590
2580	RANFILE=1: RANDOMIZE VAL(RIGHT$(TIME$,2)): NCHRS=0: NGRPS=0
2590  '
2600  ' select speed
2610  INPUT "Enter keying speed in words per minute: ", WPM
2620  '
2630  CLS
2640  RETURN
