10 REM MINMORSE.BAS --- V.1.7-PC - IBM PC keyboard only 25wpm version.
20 REM This program is in the public domain.
30 SPD=2400 : REM SPEED COUNTER FOR TIMING LOOP.
40 PUP%=INP(&H3FB) : PDWN%=PUP% OR &H40 : SIL=32767 : WPM=25 : WT=1!
50 PRINT: PRINT: PRINT: PRINT: PRINT: PRINT: PRINT: PRINT: PRINT:PRINT
60 PRINT"****************************************";
70 PRINT"***************************************"
80 PRINT"*    MinMorse.bas --- version 1.6 --- Oc";
90 PRINT"tober-31-1995 for the IBM 4mhz PC.    *"
100 PRINT"****************************************";
110 PRINT"***************************************"
120 PRINT
130 PRINT"This program keys Morse code out pin 2 o";
140 PRINT"f the IBM PC serial port to pin 7(GND)."
150 PRINT
160 PRINT"The default keying rate is 25 wpm.  Ente";
170 PRINT"r ESC followed by the new keying rate"
180 PRINT"if you wish to change the keying rate.  ";
190 PRINT"Enter ESC 0 to key the standard PARIS"
200 PRINT"test pattern at 20wpm for 1 minute.  Ent";
210 PRINT"er ESC 1 to exit the program to DOS."
220 PRINT"Enter ESC 2 to set the keying weighting."
230 PRINT
240 PRINT"****************************************";
250 PRINT"***************************************"
260 PRINT
270 REM
280 REM Morse Code Translation Table (full ITU Morse capability).
290 NUMCODES=60
300 DIM CODES$(60)
310 DIM CHARS$(60)
320 FOR I=0 TO NUMCODES-1 : READ CODES$(I) : NEXT I
330 FOR I=0 TO NUMCODES-1 : READ CHARS$(I) : NEXT I
340 REM Morse Code Translation Table From 1992 ARRL Handbook
350 REM Code strings, in one-to-one correspondence with characters, below.
360 DATA ".-", "-...", "-.-.", "-..", ".", "..-.", "--.", "...."
370 DATA "..", ".---", "-.-", ".-..", "--"
380 DATA "-.", "---", ".--.", "--.-", ".-.", "...", "-"
390 DATA "..-", "...-", ".--", "-..-", "-.--", "--.."
400 DATA "-----", ".----", "..---", "...--", "....-", "....."
410 DATA "-....", "--...", "---..", "----."
420 DATA ".-.-.-", "--..--", "-..-.", "..--..", "-....-", "-...-"
430 DATA "...-..-", "-.--.", "-.--.-", "-.-.-.", "---...", ".-.-.", ".----."
440 DATA ".-..-."
450 DATA ".-.-.."
460 DATA "..--.-"
470 DATA "...-.-"
480 DATA "-...-.-"
490 DATA ".-..."
500 DATA "-.-.-"
510 DATA "...-."
520 DATA "........"
530 DATA ".-.-", "..--"
540 REM add additional ones here
550 REM Characters recognized by the program.
560 DATA "A", "B", "C", "D", "E", "F", "G", "H"
570 DATA "I", "J", "K", "L", "M"
580 DATA "N", "O", "P", "Q", "R", "S", "T"
590 DATA "U", "V", "W", "X", "Y", "Z"
600 DATA "0", "1", "2", "3", "4", "5"
610 DATA "6", "7", "8", "9"
620 DATA ".", ",", "/", "?", "-", "="
630 DATA "$", "(", ")", ";", ":", "+", "'"
640 DATA 34 
650 DATA "@"
660 DATA "_"
670 DATA "\"
680 DATA "]"
690 DATA "["
700 DATA "{"
710 DATA "}"
720 DATA "|", "<", ">"
730 REM add additional ones here
740 REM
750 REM Calculate element timings. units are for-next loop iterations.
760 REM A dit=1, dah=3, ditspace=1, characterspace=3, wordspace=7 units.
770 REM A SPD value should be set at the top of the program to set timing loops.
780 ELE=INT(SPD/WPM): DIT=ELE: DAH=3*DIT: CHARSP=INT(2*ELE): WRTSP=INT(6*ELE)
790 REM Define character type checking functions
800 DEF FNLOWER(C$) = "a"<=C$ AND C$<="z"
810 DEF FNUPPER(C$) = "A"<=C$ AND C$<="Z"
820 DEF FNDIGIT(C$) = "0"<=C$ AND C$<="9"
830 DEF FNTOUPPER$(C$) = CHR$(ASC(C$)-32)
840 REM
850 REM Main loop to generate each character and key and/or print it.
860 C$=INPUT$(1)
870 IF C$=CHR$(27) THEN GOSUB 1450: GOTO 860
880 IF " "=C$ OR C$=CHR$(13) THEN GOSUB 1300: GOTO 1230
890 IF "."=C$ THEN MORSE=36: GOTO 1180  ' set morse to codes$ array index
900 IF ","=C$ THEN MORSE=37: GOTO 1180
910 IF "/"=C$ THEN MORSE=38: GOTO 1180
920 IF "?"=C$ THEN MORSE=39: GOTO 1180
930 IF "-"=C$ THEN MORSE=40: GOTO 1180
940 IF "=" = C$ THEN MORSE=41: GOTO 1180
950 IF "$" = C$ THEN MORSE=42: GOTO 1180
960 IF "(" = C$ THEN MORSE=43: GOTO 1180
970 IF ")" = C$ THEN MORSE=44: GOTO 1180
980 IF ";" = C$ THEN MORSE=45: GOTO 1180
990 IF ":" = C$ THEN MORSE=46: GOTO 1180
1000 IF "+" = C$ THEN MORSE=47: GOTO 1180
1010 IF "'" = C$ THEN MORSE=48: GOTO 1180
1020 IF CHR$(34) = C$ THEN MORSE=49: GOTO 1180
1030 IF "@" = C$ THEN MORSE=50: GOTO 1180
1040 IF "_" = C$ THEN MORSE=51: GOTO 1180
1050 IF "\" = C$ THEN MORSE=52: GOTO 1180
1060 IF "]" = C$ THEN MORSE=53: GOTO 1180
1070 IF "[" = C$ THEN MORSE=54: GOTO 1180
1080 IF "{" = C$ THEN MORSE=55: GOTO 1180
1090 IF "}" = C$ THEN MORSE=56: GOTO 1180
1100 IF "|" = C$ THEN MORSE=57: GOTO 1180
1110 IF "<" = C$ THEN MORSE=58: GOTO 1180
1120 IF ">" = C$ THEN MORSE=59: GOTO 1180
1130 ' add more here as needed
1140 IF FNLOWER(C$) THEN C$ = FNTOUPPER$(C$)
1150 IF FNUPPER(C$) THEN MORSE=ASC(C$)-ASC("A"):  GOTO 1180
1160 IF FNDIGIT(C$) THEN MORSE=ASC(C$)-ASC("0")+26: GOTO 1180
1170 GOTO 1240   ' non-morse character so skip it
1180 ' sound dit for each ".", dah for each "-" in string codes$(morse)
1190 FOR I=1 TO LEN(CODES$(MORSE))
1200   IF MID$(CODES$(MORSE),I,1) = "." THEN GOSUB 1330 ELSE GOSUB 1390
1210 NEXT
1220 GOSUB 1270
1230 REM PRINT C$;
1240 GOTO 850
1250 REM
1260 REM Delay an intercharacter space.
1270 REM
1280 FOR J=1 TO CHARSP : NEXT J : RETURN
1290 REM Delay an interword space.
1300 REM
1310 FOR J=1 TO WRDSP : NEXT J : RETURN
1320 REM Key a dit and a ditspace.
1330 OUT &H3FB,PDWN% : SOUND 600,250
1340 FOR J=1 TO DIT : NEXT J
1350 OUT &H3FB,PUP% : SOUND 600,0
1360 FOR J=1 TO DIT : NEXT J
1370 RETURN
1380 REM Key a dah and a ditspace.
1390 OUT &H3FB,PDWN% : SOUND 600,250
1400 FOR J=1 TO DAH : NEXT J
1410 OUT &H3FB,PUP% : SOUND 600,0
1420 FOR J=1 TO DIT : NEXT J
1430 RETURN
1440 REM
1450 REM Get speed in wpm
1460 INPUT "Enter keying speed in wpm.....",WPM
1470 IF (WPM<1) THEN WPM=20: C$=" ": GOSUB 1580
1480 IF (WPM=1) THEN STOP
1490 IF (WPM=2) THEN GOSUB 1740
1500 IF (WPM>99) THEN GOTO 1460
1510 REM calculate element timings.
1520 REM weighting is a multiplier of 1.00 to 2.00 times elemental dit value
1530 REM
1540 ELE=INT(SPD/WPM)
1550 DIT=INT(ELE*WT): DAH=3*DIT: CHARSP=INT(2*ELE): WRDSP=INT(6*ELE)
1560 RETURN
1570 REM
1580 REM Send test PARIS pattern at 20 wpm with no weighting.
1590 WPM=20: DIT=INT(SPD/WPM): DAH=3*DIT: CHARSP=INT(2*DIT): WRDSP=INT(6*DIT)
1600 FOR L=1 TO 20
1610 M=15:GOSUB 1670:M=0:GOSUB 1670:M=17:GOSUB 1670:M=8:GOSUB 1670:M=18:GOSUB 1670
1620 GOSUB 1300
1630 NEXT L
1640 GOSUB 1300
1650 RETURN
1660 REM
1670 FOR I=1 TO LEN(CODES$(M))
1680   IF MID$(CODES$(M),I,1) = "." THEN GOSUB 1330 ELSE GOSUB 1390
1690 NEXT I 
1700 GOSUB 1270
1710 REM PRINT C$;
1720 RETURN
1730 REM
1740 INPUT"Enter weighted keying speed in wpm.....",WPM
1750 INPUT"Enter weighting factor from 0-100 percent weighting.....",WT
1760 IF (WT<0) OR (WT>100) THEN GOTO 1750
1770 WT=1!+(WT/100!) ' set the weighting multiplier 1.00-2.00
1780 WPM=INT(WPM*WT) ' set the wpm faster to compensate for weighting
1790 RETURN
